<template>
    <div class="spinner" v-if="hasUri">
        <b-spinner variant="primary" type="grow" class="custom-spinner-size" label=""></b-spinner>
        <p class="blue-text mt-3">Loading...</p>
    </div>
    <div v-else>
        <h2 class="_animation-fade">{{ $t("QR.SCAN_QR_TITLE") }}</h2>
        <em>{{ $t("QR.SCAN_QR_TIP") }}</em>
        <video id="scanner-video" class="image-fluid mx-auto img-thumbnail"></video>
        <input type="text" class="form-control border-primary mb-2 mx-auto" v-model="oidcUri">
        <button :disabled="oidcUri == null" class="btn btn-primary" @click="start(null)">Start</button>
    </div>
</template>
	
<script>
import QrScanner from 'qr-scanner';
export default {
	name: "ScanQRCode",
  data() {
    return {
      oidcUri: null,
      hasUri: false
    }
  },
  methods: {
    async startIssuance() {
      await this.$axios.$post('/api/wallet/issuance/startIssuerInitiatedIssuance', {
        "oidcUri": this.oidcUri
      }).then(sessionId => {
        this.$router.replace("/InitiateIssuance?sessionId=" + sessionId)
      }, reason => {
        this.$router.replace("/IssuanceError?reason=" + reason)
      })
    },
    async startPresentation() {
      await this.$axios.$post('/api/wallet/presentation/startPresentation', {
        "oidcUri": this.oidcUri
      }).then(sessionId => {
        this.$router.replace("/CredentialRequest/?sessionId=" + sessionId)
      }, reason => {
        this.$router.replace("/IssuanceError?reason=" + reason)
      })
    },
    async start(requestType) {
      if(requestType == null) {
        if((this.oidcUri).startsWith('openid://')) {
            requestType = await this.detectRequestType(this.oidcUri)
        } else {
            let request = JSON.parse(this.oidcUri)
            if(request.request ==="import") {
                this.$store.commit('wallet/setImport', request.credential)
                this.$router.replace("/ImportCredential")
            }
            if(request.request ==="sign") {
                this.$store.commit('wallet/setImport', request.credential)
                this.$router.replace("/Selfsign")
            }
        }
        
      }
      if(requestType == "credential-offer") {
        this.startIssuance();
      } else if(requestType == "presentation-request") {
        this.startPresentation();
      } else {
        console.log("Request type unknown")
      }
    },
    async detectRequestType(uri) {
      return await this.$axios.$get('/api/wallet/oidc/detectRequestType', 
        { 
          params: { uri }
        }
      )
    },
    async checkScanResult(result) {
      return await this.detectRequestType(result.data)
    }
  },
  mounted() {
    let query = this.$route.query;
    if (query && query.url && query.credential_type && query['pre-authorized_code'] && query.user_pin_required) {
        this.hasUri = true;
        this.oidcUri = `${query.url}&credential_type=${query.credential_type}&pre-authorized_code=${query['pre-authorized_code']}&user_pin_required=${query.user_pin_required}`;
        this.start(null);
    } else {
        const qrScanner = new QrScanner(document.getElementById("scanner-video"), 
        async result => {
            const requestType = await this.checkScanResult(result)
            if(requestType == "credential-offer" || requestType == "presentation-request") {
                qrScanner.stop()
                this.oidcUri = result.data;
                this.start(requestType);
            } else {
                console.log("Failed to parse QR code", result.data)
            }
        },
        {
            highlightScanRegion: true,
            highlightCodeOutline: true
        });
        qrScanner.start()
    }
  }
}
</script>
	
<style scoped>
	.spinner {
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;
        size: 50px;
        padding: 20px;
    }
    .custom-spinner-size {
        width: 4rem; /* Adjust the width and height as needed */
        height: 4rem;
    }

    .blue-text {
        color: #007bff !important;
    }
</style>